#!/usr/bin/perl

require('./admin/adminmain.pl');
require('./initiate.pl');
require('./quirex-lib.pl');

use CGI ':standard';

srand(time+getpid);

$logged = &CheckCookie();
	if (param('action') eq 'login') {
		$PasswordCorrect = &CheckPassword;
		if ($PasswordCorrect) {
			$mycookie = &WriteSession;
			$command = '&ShowPanel';
			}
		else {
			$command = '&Login("Password incorrect! Please enter again.")';
			}
		}
	elsif (param('action') eq 'logout') {
		if ($logged) {
			$mycookie = &DeleteSession;
			$command = '&Logout';
			}
		else {
			$command = '&Login("You have not logged in!")';
			}
		}
	else {
		if (not $logged) {
			$command = '&Login' if not $logged;
			}
		else {
			if (param('action') eq 'add') {
				$command = '&AddQuiz';
				}
			elsif (param('action') eq 'add2') {
				$command = '&AddQuiz2';
				}
			elsif (param('action') eq 'edit') {
				$command = '&EditQuiz';
				}
			elsif (param('action') eq 'viewques') {
				$command = '&ViewQuestions';
				}
			elsif (param('action') eq 'addques') {
				$command = '&AddQuestions';
				}
			elsif (param('action') eq 'addques2') {
				$command = '&AddQuestions2';
				}
			elsif (param('action') eq 'removeques') {
				$command = '&RemoveQuestions';
				}
			elsif (param('action') eq 'removeques2') {
				$command = '&RemoveQuestions2';
				}
			elsif (param('action') eq 'editquizinfo') {
				$command = '&EditQuizInfo';
				}
			elsif (param('action') eq 'editquizinfo2') {
				$command = '&EditQuizInfo2';
				}
			elsif (param('action') eq 'remove') {
				$command = '&RemoveQuiz';
				}
			elsif (param('action') eq 'remove2') {
				$command = '&RemoveQuiz2';
				}
			elsif (param('action') eq 'config') {
				$command = '&EditConfig';
				}
			elsif (param('action') eq 'configdone') {
				$command = '&SaveConfig';
				}
			else {
				$command = '&ShowPanel';
				}
			}
		}

print header(-cookie => $mycookie);

flock(TEMP, 2);
open(TEMP, $template) or error("Cannot open $template: $!");

while (my $line = <TEMP>) {
	if ($line =~ /(.*)<QUIREX>(.*)/i) {
		print $1;
		
		eval($command);

		print $2;
		}
	else {
		print $line;
		}
	}

close(TEMP);
flock(TEMP, 8);


