
sub ShowQuizList {
	my $msg = shift;

	flock(LIST, 2);
	open(LIST, "$db_dir/quirex.lst") or error("Cannot open quirex.lst: $!");
	@lines = <LIST>;
	close(LIST);
	flock(LIST, 8);	
	
	foreach $line (@lines) {
		my ($dbname, $name, $desc, $level) = split(/\|\|/, $line);
		$quizzes = {dbname => $dbname, name => $name, desc => $desc, level => $level};
		push(@{$quizlevels[$level]}, $quizzes);
		}

	print "<form action=\"$script\" method=\"post\">\n";
	print "<table border=0 cellspacing=0 cellpadding=1 bgcolor=#000000 width=95%><tr><td>\n";
	print "<table border=0 cellspacing=1 cellpadding=1 width=100%>\n";

	print "<tr bgcolor=$table{'color1'}>\n";
	print "<td width=30><font color=$table{'color1'} size=1>.</font></td>\n";
	print "<td width=100%><font$font_para size=1><b>Quiz</b></font></td>\n";
	print "<td width=50 align=center nowrap><font$font_para size=1><b>Total Takers</b></font></td>\n";
	print "<td width=50 align=center nowrap><font$font_para size=1><b>Record Holder</b></font></td>\n";
	print "</tr>\n";
	
	for ($i=0;$i<=3;$i++) {
		print "<tr bgcolor=$table{'color1'}><td colspan=4><font$font_para size=3><b><i>$levelnames[$i]</i></b></font></td></tr>\n" if ($i != 0 && defined(@{$quizlevels[$i]}));
			
		foreach $quiz (@{$quizlevels[$i]}) {
		
			print "<tr bgcolor=$table{'color2'}>\n";
		
			print "<td align=center><input type=\"radio\" name=\"quiz\" value=\"${$quiz}{'dbname'}\"></td>\n";
			print "<td><font$font_para size=2><b>${$quiz}{'name'}</b><br><font size=1>${$quiz}{'desc'}</font></font></td>\n";
			print "<td align=center><font$font_para size=1><a href=\"$script?quiz=${$quiz}{'dbname'}&show=recent$recent_num\">".&getNumLine((${$quiz}{'dbname'}).'.rec')."</a></font></td>\n";
			print "<td align=center><font$font_para size=1><a href=\"$script?quiz=${$quiz}{'dbname'}&show=top$top_num\">".&getRecordHolder(${$quiz}{'dbname'})."</a></font></td>\n";
				
			print "</tr>\n";
			
			}
		}

	print "<tr bgcolor=$table{'color1'}><td colspan=4><font$font_para size=2>Number of Questions: <select name=\"number\">";
	foreach $option (@num_options) {print "<option value=\"$option\">$option";}
	print "</select></font></td></tr>\n";

	print "<tr><td bgcolor=#ff0000  colspan=4><font$font_para size=2><font color=#ffffff><b>$msg</b></font></font></td></tr>\n" if $msg ne "";

	print "<tr bgcolor=$table{'color1'}><td colspan=4><font$font_para size=2>\n";
	print "Name: <input type=text name=name size=20 maxlength=40> ";
	print "E-mail:<input type=text name=email size=20> <i>(both required)</i><br>";
	print "Check here if you want to hide your email address: <input type=\"checkbox\" name=\"hide\">";
	print "</font></td></tr>\n";

	print "<tr bgcolor=$table{'color1'}><td colspan=4 align=center><font$font_para size=2><input type=submit value=\"Take the quiz now!\" style=\"background-color: $table{'color2'}; font-family: $font{'face'}\"></font></td></tr>\n";
	print "<tr bgcolor=$table{'color1'}><td colspan=4 align=right><font$font_para size=1>Powered by <a href=\"http://www.cgihk.com\">Quirex v$version</a></font></td></tr>\n" if $show_copyright;


	print "</table>\n";
	print "</td></tr></table>\n";

	print "<input type=hidden name=action value=quiz>\n";
	print "</form>\n";



}

sub ShowQuiz {
	my $quiz = shift;
	my $num_ques = getNumLine("$quiz.db");

	$limit = param('number') > 0 ? param('number') : $num_ques;
	$limit = $num_ques if $limit > $num_ques;

	for ($i=0;$i<$num_ques;$i++) {$array[$i] = $i;}
	for ($i=0;$i<$num_ques;$i++) {
		$x = $array[int(rand($num_ques))];
		$y = $array[int(rand($num_ques))];

		$temp      = $array[$x];
		$array[$x] = $array[$y];
		$array[$y] = $temp;
		}

	splice(@array, $limit);

	flock(2, DB);
	open(DB, "$db_dir/$quiz.db") or error("Cannot open $quiz.db: $!");
	@lines = <DB>;
	close(DB);
	flock(8, DB);

	print "<form action=\"$script\" method=\"POST\">\n";
	print "<table border=0 cellspacing=0 cellpadding=1 bgcolor=#000000 width=95%><tr><td>\n";
	print "<table border=0 cellspacing=1 cellpadding=1 width=100%>\n";
	print "<tr><td bgcolor=$table{'color1'}><font$font_para size=3><b><i>".getQuizName($quiz)."</i></b></font></td></tr>\n";

	$i = 1;
	foreach $linenum (@array) {
		my $j = 'color' . (($i % 2) + 1);
		($qtype, $question, $qimage, $answer, $aimage, $explanation, $choice) = split(/\|\|/, $lines[$linenum]);

		print "<tr bgcolor=$table{$j}><td width=100%><font$font_para size=2><b>$i. $question</b>";
		print "<br><img src=\"http://$qimage\">" if $qimage ne "";
		if ($qtype eq "mc") {
			chomp($choice);
			@choices = split(/\`\`/, $choice);
			foreach $choice (@choices) {
				print "<br><input type=\"radio\" name=\"$linenum\" value=\"$choice\">$choice";
				}
			}
		if ($qtype eq "sa") {
			print "<br>Answer: <input type=\"text\" name=\"$linenum\" size=30>";
			}
		if ($qtype eq "nu") {
			print "<br>Answer: <input type=\"text\" name=\"$linenum\" size=30> (Enter only numeric value)";
			}
		if ($qtype eq "tf") {
			print "<br><input type=\"radio\" name=\"$linenum\" value=\"t\">True <input type=\"radio\" name=\"$linenum\" value=\"f\">False";
			}

		print "</font></td></tr>\n";

		$i++;

		}

	if (param('name') eq "" || param('email') eq "") {
		print "<tr bgcolor=$table{'color1'}><td><font$font_para size=2>\n";
		print "Name: <input type=text name=name size=20 maxlength=40> ";
		print "E-mail:<input type=text name=email size=20> <i>(both required)</i><br>";
		print "Check here if you want to hide your email address: <input type=\"checkbox\" name=\"hide\">";
		print "</font></td></tr>\n";
		}
	else {
		print "<input type=hidden name=name value=\"".param('name')."\">";
		print "<input type=hidden name=email value=\"".param('email')."\">";
		print "<input type=hidden name=hide value=\"".param('hide')."\">";
		}

	print "<tr bgcolor=$table{'color1'}><td align=center><font$font_para size=2><input type=submit value=\"I'm Done!\" style=\"background-color: $table{'color2'}; font-family: $font{'face'}\"></font></td></tr>\n";
	print "<tr bgcolor=$table{'color1'}><td align=right><font$font_para size=1>Powered by <a href=\"http://www.cgihk.com\">Quirex v$version</a></font></td></tr>\n" if $show_copyright;
	print "</table>\n";
	print "</td></tr></table>\n";	
	print "<input type=\"hidden\" name=\"quiz\" value=\"$quiz\">\n";
	print "<input type=\"hidden\" name=\"number\" value=\"$limit\">\n";
	print "<input type=\"hidden\" name=\"action\" value=\"done\">\n";
	print "<input type=\"hidden\" name=\"array\" value=\"".join(",", @array)."\">\n";
	print "</form>\n";
	}

sub CheckAnswers {
	my $quiz = shift;
	$takername = param('name');
	$email = param('email');
	$hide = param('hide') || 'off';

	my $temp = param('array');
	@array = split(/,/, $temp);
	$total = $#array + 1;
	$correct = 0;

	foreach $name (param()) {
		if ($name =~ /^\d+$/) {
			$submitted[$name] = param($name);
			}
		}

	flock(2, DB);
	open(DB, "$db_dir/$quiz.db") or error("Cannot open $quiz.db: $!");
	@lines = <DB>;
	close(DB);
	flock(8, DB);

	print "<form action=\"$script\" method=\"POST\">\n";
	print "<table border=0 cellspacing=0 cellpadding=1 bgcolor=#000000 width=95%><tr><td>\n";
	print "<table border=0 cellspacing=1 cellpadding=1 width=100%>\n";
	print "<tr bgcolor=$table{'color1'}><td colspan=2><font$font_para size=3><b><i>".getQuizName($quiz)."</i></b></font></td></tr>\n";
	print "<tr bgcolor=$table{'color1'}><td colspan=2><font$font_para size=2><b>Quiz Results for $takername &lt;$email&gt;:</b></font></td></tr>\n";

	$i = 1;
	foreach $linenum (@array) {
		my $j = 'color' . (($i % 2) + 1);
		($qtype, $question, $qimage, $answer, $aimage, $explanation, $choice) = split(/\|\|/, $lines[$linenum]);

		print "<tr bgcolor=$table{$j}>";
		print "<td>";
		if ($qtype eq "mc" || $qtype eq "nu" ||  $qtype eq "tf") {
			if ($answer eq $submitted[$linenum]) {
				print "<img src=\"$url_tick\">"; 
				$correct++;
				}
			else {
				print "<img src=\"$url_cross\">";
				}
			}
		elsif ($qtype eq "sa") {
			@answers = split(/\`\`/, $answer);
			$found = 0;
			foreach $answer (@answers) {
				$found = 1 if $answer =~ /^$submitted[$linenum]$/i;
				}
			if ($found) {
				print "<img src=\"$url_tick\">";
				$correct++;
				}
			else {
				print "<img src=\"$url_cross\">";
				}
			}
		print "</td>";
		print "<td width=100%><font$font_para size=2><b>$i. $question</b>";
		print "<br>Your answer: " . ($submitted[$linenum] eq "" ? "N/A" : $submitted[$linenum]);
		if ($show_answer) {
			$answer = join(', ', @answers) if $qtype eq "sa";
			if ($qtype eq "tf") {
				print "<br><b>Correct answer:</b> ". ($answer eq 't' ? 'True' : 'False');
				}
			else {print "<br><b>Correct answer:</b> $answer";}
			print "<br><img src=\"http://$aimage\">" if $aimage ne "";
			print "<br><b>Explanation:</b> $explanation" if $explanation ne "";
			}
		print "</font></td></tr>\n";

		$i++;

		}

	$score2d = int(($correct/$total)*10000 + 0.5)/100;
	print "<tr bgcolor=$table{'color1'}><td colspan=2><font$font_para size=3><b><i>You have got $correct correct out of $total questions.</i></b></font></td></tr>\n";
	print "<tr bgcolor=$table{'color1'}><td colspan=2><font$font_para size=3><b><i>Your score is $score2d.</i></b></font></td></tr>\n";
	print "<tr bgcolor=$table{'color1'}><td colspan=2 align=center><font$font_para size=2><input type=submit value=\"Take the Quiz again!\" style=\"background-color: $table{'color2'}; font-family: $font{'face'}\"></font></td></tr>\n";
	print "<input type=\"hidden\" name=\"quiz\" value=\"$quiz\">\n";
	print "<input type=\"hidden\" name=\"number\" value=\"".param('number')."\">\n";
	print "<input type=\"hidden\" name=\"name\" value=\"$takername\">\n";
	print "<input type=\"hidden\" name=\"email\" value=\"$email\">\n";
	print "</form>\n";
	print "<form action=\"$script\" method=\"POST\">\n";
	print "<tr bgcolor=$table{'color1'}><td colspan=2 align=center><font$font_para size=2><input type=submit value=\"Take another Quiz!\" style=\"background-color: $table{'color2'}; font-family: $font{'face'}\"></font></td></tr>\n";
	print "</form>\n";
	print "<tr bgcolor=$table{'color1'}><td colspan=2 align=right><font$font_para size=1>Powered by <a href=\"http://www.cgihk.com\">Quirex v$version</a></font></td></tr>\n" if $show_copyright;
	print "</table>\n";
	print "</td></tr></table>\n";	


	$takername =~ s/\|//g;
	$email =~ s/\|//g;
	
	$time = time();
	flock(2, REC);
	open(REC, ">>$db_dir/$quiz.rec") or error("Cannot open $quiz.rec: $!");
	print REC "$takername\|\|$email\|\|$hide\|\|$total\|\|$correct\|\|$time\n";
	close(REC);
	flock(8, REC);
	
	if ($email_admin) {
		open(MAIL, "|$sendmail $admin_email") or error("Cannot run $sendmail: $!");
		print MAIL "From: \"Quirex v$version\" <$admin_email>\n";
		print MAIL "To: $admin_email\n";
		print MAIL "Subject: Someone has took the quiz ".getQuizName($quiz)."\n\n";
		print MAIL "Quiz Taker         : $takername\n";
		print MAIL "Quiz Taker Email   : $email\n";
		print MAIL "Quiz Taken         : ".getQuizName($quiz)."\n";
		print MAIL "Time               : ".getTime($time)."\n";
		print MAIL "Questions Attemped : $total\n";
		print MAIL "No. of Correct Ans : $correct\n";
		print MAIL "Score              : $score2d\n";
		close(MAIL);
		}

	if ($email_taker) {
		open(MAIL, "|$sendmail $email") or error("Cannot run $sendmail: $!");
		print MAIL "From: $admin_email\n";
		print MAIL "To: \"$takername\" <$email>\n";
		print MAIL "Subject: Thank you for taking the quiz ".getQuizName($quiz)."\n\n";
		print MAIL "Here is a simple report for the quiz you have taken.\n\n";
		print MAIL "Quiz Taken         : ".getQuizName($quiz)."\n";
		print MAIL "Time               : ".getTime($time)."\n";
		print MAIL "Questions Attemped : $total\n";
		print MAIL "No. of Correct Ans : $correct\n";
		print MAIL "Score              : $score2d\n\n";
		print MAIL "Feel free to come back and check out our site at\n";
		print MAIL "$siteurl soon!\n";
		close(MAIL);
		}
	}

1;
