sub CheckPassword {
	return 1 if param('password') eq $admin_password;
	return 0 if param('password') ne $admin_password;
}

sub CheckCookie {
	my $mysession = cookie('session');
	
	my $temp = 0;
	
	flock(CODE, 2);
	open(CODE, "./admin/session.code") or error("Cannot open session.code: $!");
	while ($code = <CODE>) {
		chomp($code);
		$temp = 1 if $code eq $mysession;
		}
	close(CODE);
	flock(CODE, 8);

	return $temp;
	}

sub WriteSession {
	my $sessionid = rand(time+getpid);
	
	flock(CODE, 2);
	open(CODE, "./admin/session.code") or error("Cannot open session.code: $!");
	@lines = <CODE>;
	close(CODE);
	flock(CODE, 8);
	
	flock(CODE, 2);
	open(CODE, ">./admin/session.code") or error("Cannot open session.code: $!");
	foreach $line (@lines) {
		chomp($line);
		if ($line ne $sessionid) {
			push(@temp, "$line\n");
			}
		}
	shift(@temp) if $#temp >= 4;
	
	push(@temp, "$sessionid\n");
	
	my $i = 0;
	foreach $line (@temp) {
		print CODE $line if $i < 5;
		$i++;
		}
	close(CODE);
	flock(CODE, 8);
	
	return cookie(-name => 'session', -value => $sessionid, -expire => '+1d');
	}

sub DeleteSession {
	my $mysession = cookie('session');

	flock(CODE, 2);
	open(CODE, "./admin/session.code") or error("Cannot open session.code: $!");
	@lines = <CODE>;
	close(CODE);
	flock(CODE, 8);
	
	flock(CODE, 2);
	open(CODE, ">./admin/session.code") or error("Cannot open session.code: $!");
	foreach $line (@lines) {
		chomp($line);
		if ($line ne $mysession) {
			print CODE "$line\n";
			}
		}
	close(CODE);
	flock(CODE, 8);
	
	return cookie(-name => 'session', -value => '');
	}

sub Login {
	$errmsg = shift;
	
	print "<form action=\"$script\" method=\"post\">\n";
	print "<table border=0 cellspacing=0 cellpadding=1 bgcolor=#000000 width=500 align=center><tr><td>\n";
	print "<table border=0 cellspacing=1 cellpadding=1 width=100%>\n";
	print "<tr><td bgcolor=$table{'color1'}><font$font_para size=3><i><b>Quirex Administration Login</b></i></font></td></tr>\n";
	print "<tr><td bgcolor=#ff0000><font$font_para size=2><font color=#ffffff><b>Error:</b> $errmsg</font></font></td></tr>\n" if $errmsg ne "";
	print "<tr><td bgcolor=$table{'color2'}><font$font_para size=2>Password: <input type=password name=password> <input type=submit value=\"Login\" style=\"background-color: $table{'color2'}; font-family: $font{'face'}\"></font></td></tr>\n";
	print "<tr><td bgcolor=$table{'color1'} align=right><font$font_para size=1>Powered by <a href=\"http://www.cgihk.com\">Quirex v$version</a></font></td></tr>\n";
	print "</table>\n";
	print "</td></tr></table>\n";
	print "<input type=hidden name=action value=login>\n";
	print "</form>\n";
	}

sub Logout {
	print "<table border=0 cellspacing=0 cellpadding=1 bgcolor=#000000 width=500 align=center><tr><td>\n";
	print "<table border=0 cellspacing=1 cellpadding=1 width=100%>\n";
	print "<tr><td bgcolor=$table{'color1'}><font$font_para size=3><i><b>Quirex Administration Logout</b></i></font></td></tr>\n";
	print "<tr><td bgcolor=$table{'color2'}><font$font_para size=2>You have successfully logged out.</font></td></tr>\n";
	print "<tr><td bgcolor=$table{'color1'} align=right><font$font_para size=1>Powered by <a href=\"http://www.cgihk.com\">Quirex v$version</a></font></td></tr>\n";
	print "</table>\n";
	print "</td></tr></table>\n";

	}


1;